{
    attributes = (
        {
            allowsNull = Y; 
            columnName = "CAN_ID"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_CAN_ID"; }; 
            name = canId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "CON_ORDRE"; 
            externalType = NUMBER; 
            name = conOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "ECHE_ID"; 
            externalType = NUMBER; 
            name = echeId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "ENG_ID"; 
            externalType = NUMBER; 
            name = engId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "EXE_ORDRE"; 
            externalType = NUMBER; 
            name = exeOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAC_ID"; 
            externalType = NUMBER; 
            name = facId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "FAP_APPLY_TVA"; 
            externalType = VARCHAR2; 
            internalInfo = {"_nameInObjectStore" = "PREST_FORCE_TVA"; }; 
            name = fapApplyTva; 
            valueClassName = NSString; 
            valueType = S; 
            width = 1; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_COMMENTAIRE_CLIENT"; 
            externalType = VARCHAR2; 
            name = fapCommentaireClient; 
            valueClassName = NSString; 
            valueType = S; 
            width = 1000; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_COMMENTAIRE_PREST"; 
            externalType = VARCHAR2; 
            name = fapCommentairePrest; 
            valueClassName = NSString; 
            valueType = S; 
            width = 1000; 
        }, 
        {
            columnName = "FAP_DATE"; 
            externalType = DATE; 
            name = fapDate; 
            valueClassName = NSCalendarDate; 
            valueType = T; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_DATE_LIMITE_PAIEMENT"; 
            externalType = DATE; 
            name = fapDateLimitePaiement; 
            valueClassName = NSCalendarDate; 
            valueType = T; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_DATE_REGLEMENT"; 
            externalType = DATE; 
            name = fapDateReglement; 
            valueClassName = NSCalendarDate; 
            valueType = T; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_DATE_VALIDATION_CLIENT"; 
            externalType = DATE; 
            name = fapDateValidationClient; 
            valueClassName = NSCalendarDate; 
            valueType = T; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_DATE_VALIDATION_PREST"; 
            externalType = DATE; 
            name = fapDateValidationPrest; 
            valueClassName = NSCalendarDate; 
            valueType = T; 
        }, 
        {
            columnName = "FAP_ID"; 
            externalType = NUMBER; 
            isReadOnly = N; 
            name = fapId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "FAP_LIB"; 
            externalType = VARCHAR2; 
            name = fapLib; 
            valueClassName = NSString; 
            valueType = S; 
            width = 500; 
        }, 
        {
            columnName = "FAP_NUMERO"; 
            externalType = NUMBER; 
            name = fapNumero; 
            valueClassName = NSNumber; 
            valueType = f; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_REF"; 
            externalType = VARCHAR2; 
            name = fapRef; 
            valueClassName = NSString; 
            valueType = S; 
            width = 100; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_REFERENCE_REGLEMENT"; 
            externalType = VARCHAR2; 
            name = fapReferenceReglement; 
            valueClassName = NSString; 
            valueType = S; 
            width = 20; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FAP_REMISE_GLOBALE"; 
            externalType = NUMBER; 
            name = fapRemiseGlobale; 
            precision = 12; 
            scale = 2; 
            valueClassName = NSDecimalNumber; 
            valueType = B; 
        }, 
        {
            columnName = "FAP_TOTAL_HT"; 
            externalType = NUMBER; 
            name = fapTotalHt; 
            precision = 12; 
            scale = 2; 
            valueClassName = NSDecimalNumber; 
            valueType = B; 
        }, 
        {
            columnName = "FAP_TOTAL_TTC"; 
            externalType = NUMBER; 
            name = fapTotalTtc; 
            precision = 12; 
            scale = 2; 
            valueClassName = NSDecimalNumber; 
            valueType = B; 
        }, 
        {
            columnName = "FAP_TOTAL_TVA"; 
            externalType = NUMBER; 
            name = fapTotalTva; 
            precision = 12; 
            scale = 2; 
            valueClassName = NSDecimalNumber; 
            valueType = B; 
        }, 
        {
            allowsNull = Y; 
            columnName = "fap_utl_validation_client"; 
            externalType = NUMBER; 
            name = fapUtlValidationClient; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "fap_utl_validation_prest"; 
            externalType = NUMBER; 
            name = fapUtlValidationPrest; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "FOU_ORDRE"; 
            externalType = NUMBER; 
            name = fouOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "FOU_ORDRE_PREST"; 
            externalType = NUMBER; 
            name = fouOrdrePrest; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "LOLF_ID"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_LOLF_ID"; }; 
            name = lolfId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "MOR_ORDRE"; 
            externalType = NUMBER; 
            name = morOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "NO_INDIVIDU"; 
            externalType = NUMBER; 
            name = noIndividu; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "ORG_ID"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_ORG_ID"; }; 
            name = orgId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "PCO_NUM"; 
            externalType = VARCHAR2; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_PCO_NUM"; }; 
            name = pcoNum; 
            valueClassName = NSString; 
            valueType = S; 
            width = 20; 
        }, 
        {
            allowsNull = Y; 
            columnName = "PCO_NUM_CTP"; 
            externalType = VARCHAR2; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_PCO_NUM"; }; 
            name = pcoNumCtp; 
            valueClassName = NSString; 
            valueType = S; 
            width = 20; 
        }, 
        {
            allowsNull = Y; 
            columnName = "PCO_NUM_TVA"; 
            externalType = VARCHAR2; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_PCO_NUM"; }; 
            name = pcoNumTva; 
            valueClassName = NSString; 
            valueType = S; 
            width = 20; 
        }, 
        {
            columnName = "PERS_ID"; 
            externalType = NUMBER; 
            name = persId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = ""; 
            definition = "initcap(personne.persLibelle||' '||personne.persLc)"; 
            externalType = VARCHAR2; 
            name = "personne_persNomPrenom"; 
            valueClassName = NSString; 
            valueType = S; 
            width = 300; 
        }, 
        {
            allowsNull = Y; 
            columnName = "PREST_ID"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "DEV_ID"; }; 
            name = prestId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "RIB_ORDRE"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_TCD_ORDRE"; }; 
            name = ribOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "TAP_ID"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_TAP_ID"; }; 
            name = tapId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            allowsNull = Y; 
            columnName = "TCD_ORDRE"; 
            externalType = NUMBER; 
            internalInfo = {"_nameInObjectStore" = "FAP_PREST_TCD_ORDRE"; }; 
            name = tcdOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "TYET_ID"; 
            externalType = NUMBER; 
            name = tyetId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "TYPU_ID"; 
            externalType = NUMBER; 
            name = typuId; 
            valueClassName = NSNumber; 
            valueType = i; 
        }, 
        {
            columnName = "UTL_ORDRE"; 
            externalType = NUMBER; 
            name = utlOrdre; 
            valueClassName = NSNumber; 
            valueType = i; 
        }
    ); 
    attributesUsedForLocking = (
        canId, 
        conOrdre, 
        echeId, 
        engId, 
        exeOrdre, 
        facId, 
        fapApplyTva, 
        fapCommentaireClient, 
        fapCommentairePrest, 
        fapId, 
        fapLib, 
        fapReferenceReglement, 
        fapUtlValidationClient, 
        fapUtlValidationPrest, 
        fouOrdre, 
        fouOrdrePrest, 
        lolfId, 
        morOrdre, 
        noIndividu, 
        orgId, 
        pcoNum, 
        pcoNumCtp, 
        pcoNumTva, 
        persId, 
        prestId, 
        ribOrdre, 
        tapId, 
        tcdOrdre, 
        tyetId, 
        typuId, 
        utlOrdre
    ); 
    className = "org.cocktail.kava.server.metier.EOFacturePapier"; 
    classProperties = (
        codeAnalytique, 
        convention, 
        echeId, 
        engageBudget, 
        exercice, 
        facture, 
        facturePapierLignes, 
        fapApplyTva, 
        fapCommentaireClient, 
        fapCommentairePrest, 
        fapDate, 
        fapDateLimitePaiement, 
        fapDateReglement, 
        fapDateValidationClient, 
        fapDateValidationPrest, 
        fapLib, 
        fapNumero, 
        fapRef, 
        fapReferenceReglement, 
        fapRemiseGlobale, 
        fapTotalHt, 
        fapTotalTtc, 
        fapTotalTva, 
        fournisUlr, 
        fournisUlrPrest, 
        individuUlr, 
        lolfNomenclatureRecette, 
        modeRecouvrement, 
        organ, 
        pcoNum, 
        pcoNumCtp, 
        pcoNumTva, 
        personne, 
        "personne_persNomPrenom", 
        prestation, 
        ribfourUlr, 
        tauxProrata, 
        toFacturePapierAdrClients, 
        typeCreditRec, 
        typeEtat, 
        typePublic, 
        utilisateur, 
        utilisateurValidationClient, 
        utilisateurValidationPrest
    ); 
    externalName = "jefy_recette.facture_papier"; 
    fetchSpecificationDictionary = {}; 
    internalInfo = {
        "_clientClassPropertyNames" = (
            codeAnalytique, 
            convention, 
            echeId, 
            engageBudget, 
            exercice, 
            facture, 
            facturePapierLignes, 
            fapApplyTva, 
            fapCommentaireClient, 
            fapCommentairePrest, 
            fapDate, 
            fapDateLimitePaiement, 
            fapDateReglement, 
            fapDateValidationClient, 
            fapDateValidationPrest, 
            fapLib, 
            fapNumero, 
            fapRef, 
            fapReferenceReglement, 
            fapRemiseGlobale, 
            fapTotalHt, 
            fapTotalTtc, 
            fapTotalTva, 
            fournisUlr, 
            fournisUlrPrest, 
            individuUlr, 
            lolfNomenclatureRecette, 
            modeRecouvrement, 
            organ, 
            pcoNum, 
            pcoNumCtp, 
            pcoNumTva, 
            personne, 
            "personne_persNomPrenom", 
            prestation, 
            ribfourUlr, 
            tauxProrata, 
            toFacturePapierAdrClients, 
            typeCreditRec, 
            typeEtat, 
            typePublic, 
            utilisateur, 
            utilisateurValidationClient, 
            utilisateurValidationPrest
        ); 
        "_javaClientClassName" = "org.cocktail.kava.client.metier.EOFacturePapier"; 
        "_nameInObjectStore" = "facture_papier"; 
    }; 
    name = FacturePapier; 
    primaryKeyAttributes = (fapId); 
    relationships = (
        {
            destination = CodeAnalytique; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = canId; sourceAttribute = canId; }); 
            name = codeAnalytique; 
        }, 
        {
            destination = Convention; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = conOrdre; sourceAttribute = conOrdre; }); 
            name = convention; 
        }, 
        {
            destination = EngageBudget; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = engId; sourceAttribute = engId; }); 
            name = engageBudget; 
        }, 
        {
            destination = "ca_Exercice"; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = exeOrdre; sourceAttribute = exeOrdre; }); 
            name = exercice; 
        }, 
        {
            destination = Facture; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = facId; sourceAttribute = facId; }); 
            name = facture; 
        }, 
        {
            destination = FacturePapierLigne; 
            isToMany = Y; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = fapId; sourceAttribute = fapId; }); 
            name = facturePapierLignes; 
        }, 
        {
            destination = FournisUlr; 
            internalInfo = {"_nameInObjectStore" = Relationship; }; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = fouOrdre; sourceAttribute = fouOrdre; }); 
            name = fournisUlr; 
        }, 
        {
            destination = FournisUlr; 
            internalInfo = {"_nameInObjectStore" = fournisUlr; }; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = fouOrdre; sourceAttribute = fouOrdrePrest; }); 
            name = fournisUlrPrest; 
        }, 
        {
            destination = IndividuUlr; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = noIndividu; sourceAttribute = noIndividu; }); 
            name = individuUlr; 
        }, 
        {
            destination = LolfNomenclatureRecette; 
            internalInfo = {"_nameInObjectStore" = actionRec; }; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = lolfId; sourceAttribute = lolfId; }); 
            name = lolfNomenclatureRecette; 
        }, 
        {
            destination = ModeRecouvrement; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = modOrdre; sourceAttribute = morOrdre; }); 
            name = modeRecouvrement; 
        }, 
        {
            destination = Organ; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = orgId; sourceAttribute = orgId; }); 
            name = organ; 
        }, 
        {
            destination = Personne; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = persId; sourceAttribute = persId; }); 
            name = personne; 
        }, 
        {
            destination = Prestation; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = prestId; sourceAttribute = prestId; }); 
            name = prestation; 
        }, 
        {
            destination = RibfourUlr; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = ribOrdre; sourceAttribute = ribOrdre; }); 
            name = ribfourUlr; 
        }, 
        {
            destination = TauxProrata; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = tapId; sourceAttribute = tapId; }); 
            name = tauxProrata; 
        }, 
        {
            destination = FacturePapierAdrClient; 
            isToMany = Y; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = fapId; sourceAttribute = fapId; }); 
            name = toFacturePapierAdrClients; 
        }, 
        {
            destination = "ca_TypeCredit"; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = tcdOrdre; sourceAttribute = tcdOrdre; }); 
            name = typeCreditRec; 
        }, 
        {
            destination = "ca_TypeEtat"; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = tyetId; sourceAttribute = tyetId; }); 
            name = typeEtat; 
        }, 
        {
            destination = TypePublic; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = typuId; sourceAttribute = typuId; }); 
            name = typePublic; 
        }, 
        {
            destination = Utilisateur; 
            isToMany = N; 
            joinSemantic = EOInnerJoin; 
            joins = ({destinationAttribute = utlOrdre; sourceAttribute = utlOrdre; }); 
            name = utilisateur; 
        }, 
        {
            destination = Utilisateur; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = utlOrdre; sourceAttribute = fapUtlValidationClient; }); 
            name = utilisateurValidationClient; 
        }, 
        {
            destination = Utilisateur; 
            isToMany = N; 
            joinSemantic = EOLeftOuterJoin; 
            joins = ({destinationAttribute = utlOrdre; sourceAttribute = fapUtlValidationPrest; }); 
            name = utilisateurValidationPrest; 
        }
    ); 
}
